package uniandes.cupi2.ordenador;

import java.util.Comparator;
import java.util.List;

/**
 * Clase gnerica que se encarga de ordenar colecciones de elementos de tipo T
 * @author alvar-go
 * @param <T> tipo de elementos que debe contener la coleccin a ordenar
 */
public class Ordenador<T> 
{
	/**
	 * Ordena la lista que llega por parmetro en el sentido que llega por parmetro usando el comparador que llega por parmetro
	 * post: la lista se encuentra ordenada por los cirterios ingresados
	 * @param ordenamiento el algoritmo de ordenamieto que se debe usar. ordenamiento pertenece a la enumeracin Ordenamiento
	 * @param lista la lista que se desea ordenar. lista != null
	 * @param ascendente indica si se debe ordenar de manera ascendente, de lo contrario se debe ordenar descendentemente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	public void ordenar(AlgoritmoOrdenamiento ordenamiento, List<T> lista, boolean ascendente, Comparator<T> comparador)
	{
		if(ordenamiento.equals(AlgoritmoOrdenamiento.BURBUJA))
		{
			ordenarBurbuja(lista, ascendente, comparador);
		}
		else if(ordenamiento.equals(AlgoritmoOrdenamiento.SELECCION))
		{
			ordenarSeleccion(lista, ascendente, comparador);
		}
		else if(ordenamiento.equals(AlgoritmoOrdenamiento.INSERCION))
		{
			ordenarInsercion(lista, ascendente, comparador);
		}
		else if(ordenamiento.equals(AlgoritmoOrdenamiento.SHAKER))
		{
			ordenarShaker(lista, ascendente, comparador);
		}
		else if(ordenamiento.equals(AlgoritmoOrdenamiento.GNOME))
		{
			ordenarGnome(lista, ascendente, comparador);
		}
	}

	/**
	 * Ordena la lista usando el algoritmo de inscercin
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarInsercion(List<T> lista,boolean ascendnte, Comparator<T> comparador) {
	  //TODO Parte 4 Punto 1a Implemente segn la documentacin
		
	}

	/**
	 * Ordena la lista usando el algoritmo de seleccin
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarSeleccion(List<T> lista,boolean ascendnte, Comparator<T> comparador) {
	  //TODO Parte 4 Punto 1b  Implemente segn la documentacin
		
		
	}

	/**
	 * Ordena la lista usando el algoritmo de burbuja
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarBurbuja(List<T> lista,boolean ascendnte, Comparator<T> comparador) {
	  //TODO Parte 4 Punto 1c  Implemente segn la documentacin
		
		
	}
	
	/**
	 * Ordena la lista usando el algoritmo de shake (burbuja bidireccional)
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarShaker(List<T> lista,boolean ascendnte, Comparator<T> comparador)
	{
	  //TODO Parte 4 Punto 1d  Implemente segn la documentacin
		
	}
	
	
	/**
	 * Ordena la lista usando el algoritmo de Gnome
	 * post: la lista se encuentra ordenada
	 * @param lista la lista que se desea ordenar. lsita != null
	 * @param ascendnte indica si se debe ordenar de mamenra ascendente, de lo contrario se ordenar de manera descendente
	 * @param comparador comparador de elementos tipo T que se usar para ordenar la lista, define el criterio de orden. comparador != null.
	 */
	private void ordenarGnome(List<T> lista,boolean ascendnte, Comparator<T> comparador) {
	  //TODO Parte 4 Punto 1e  Implemente segn la documentacin
		
	}
}
